#include <stdio.h>
#include <stdlib.h>

typedef struct { 
        char nome[20],cognome[20];
        long matricola;
        int anno,corso;
        } studente;
        

typedef struct  {
        long matricola;
        char data[12];
        int voto,codice;
        } esame;
        
struct atomo {
       esame dato;
       struct atomo *next;
};

void inizializza(studente *T[5], int *N)
{
 studente s;
 FILE *pf;
 studente *a;
 int ris,i,v;
 
 pf=fopen("studenti.dat","r");
 if(pf==NULL)
   {printf("Il file non esiste\n");
    return;
   }
  
 do {
 ris=fread(&s,sizeof(studente),1,pf);
 if(ris>0)
   { /* inserimento in tabella*/
       i=s.corso;
       
       a=realloc(T[i],sizeof(studente)*(N[i]+1));
       if(a==NULL)
         return;
       T[i]=a;
       T[i][N[i]]=s;
       N[i]++;
   }
 } while (ris>0);
 fclose(pf);
}

void ins_studente(studente *T[5],int *N)
{
     studente s;
     studente *a;
     int i;
     
     /* lettura studente da inserire*/
      printf("Nome: ");
      scanf("%s",s.nome);
      printf("Cognome: ");
      scanf("%s",s.cognome);
      printf("Matricola: ");
      scanf("%ld",&s.matricola);
      printf("Anno iscrizione:");
      scanf("%d",&s.anno);
      printf("Codice corso (0..4): ");
      scanf("%d",&s.corso);
      
      /* inserimento in tabella*/
      i=s.corso;
      a=realloc(T[i],sizeof(studente)*(N[i]+1));
      if(a==NULL)
         return;
      T[i]=a;
      T[i][N[i]]=s;
      N[i]++;
}

void vis_studenti(studente *T[5], int *N)
{
     int c,i;
     
     printf("Corso di laurea (0...4): ");
     scanf("%d",&c);
     
     for(i=0;i<N[c];i++)
         { printf("Matricola: %ld\n",T[c][i].matricola);
           printf("anno iscrizione: %d\n\n",T[c][i].anno);
         }
}

void salva_tabella(studente *T[5], int *N)
{
     FILE *pf;
     int c,i;
     
     pf=fopen("studenti.dat","w");
     if(pf==NULL)
      return;
     for(c=0;c<5;c++)
       for(i=0;i<N[c];i++)
         fwrite(&T[c][i],sizeof(studente),1,pf);
     
     fclose(pf);
}      

void ins_esame(struct atomo *VL[5])
{
     struct atomo *l1,*l2,*a;
     esame e;
     int i;
     
     /* lettura esame da inserire*/
       printf("Matricola: ");
       scanf("%ld",&e.matricola);
       printf("Data: ");
       scanf("%s",e.data);
       printf("Voto: ");
       scanf("%d",&e.voto);
       printf("Codice materia (0.4): ");
       scanf("%d",&e.codice);
       
       a=malloc(sizeof(struct atomo));
       if(a==NULL)
         return;
         
       a->dato=e;
       i=e.codice;
       if(VL[i]==NULL || e.matricola < VL[i]->dato.matricola)
          {  /* inserimento in testa*/
              a->next=VL[i];
              VL[i]=a;
              return;
          }
       /* inserimento in posizione successiva alla prima*/
       l1=VL[i]->next;
       l2=VL[i];
       while (l1!=NULL)
          if(e.matricola < l1->dato.matricola)
              break;
          else {
                 l1=l1->next;
                 l2=l2->next;
                 }
                 
        a->next=l1;
        l2->next=a;
}

void vis_lista(struct atomo *VL[5])
{
     int i;
     struct atomo *l;
     
     
     printf("Codice materia: (0..4) ");
     scanf("%d",&i);
     l=VL[i];
     while(l!=NULL)
       {
         printf("Matricola: %ld\n",l->dato.matricola);
         printf("Voto: %d\n\n",l->dato.voto);
         l=l->next;
         }
}

void da_testa(struct atomo **testa)
{
     struct atomo *a;
     
     a=*testa;
     *testa=a->next;
     free(a);
}   
          
       
       

main(){
       
 studente *TB[5];
 int N[5];
 
 struct atomo *L[5];
 int i,scelta;
 
 
 /* inizializzazione liste*/
  for(i=0;i<5;i++)
    L[i]=NULL;
  
  /* inizializzazione tabella*/
   for(i=0;i<5;i++)
     {  TB[i]=NULL;
        N[i]=0;
     }
   inizializza(TB,N);
   
   do {
      printf("\nScegli\n");
      printf("1) Ins.  studente\n");
      printf("2) Visualizza studenti\n");
      printf("3) Ins. esame\n");
      printf("4) Visualizza esami\n");
      printf("5) Salva su file\n");
      printf("0) fine\n\n");
      scanf("%d",&scelta);
      switch(scelta) {
       case 1:   ins_studente(TB,N);
                 break;
       case 2:   vis_studenti(TB,N);
                 break;
       case 3:   ins_esame(L);
                 break;
       case 4:   vis_lista(L);
                 break;
       case 5:   salva_tabella(TB,N);
                 break;
       default:; }
       } while(scelta!=0);
       
       /* liberazione della memoria della tabella*/
        for(i=0;i<5;i++)
         free(TB[i]);
         
        for(i=0;i<5;i++)
          while(L[i]!=NULL) /* lista non vuota*/
             da_testa(&L[i]);
}
         
         
                   
     
 
 
 
 
       
  
        
    
